﻿//==============================================================================================
//
// LPAnimation1: an animation demo for WinForms using GDI+
// Version 1.1
//
// Copyright (C) 2009, Luc Pattyn, http://www.perceler.com/
//
//==============================================================================================

using System;
using System.ComponentModel;
using System.Drawing;
using System.Windows.Forms;

namespace Animation1 {
	public partial class Form1 : Form {
		Bitmap image;
		Timer timer;
		int step;
		int steps;

		public Form1() {
			InitializeComponent();
			// get image 
			image=new Bitmap("VisualStudio2008.png");
			steps=1;
			// now draw it
			panel1.Paint+=new PaintEventHandler(panel1_Paint);
			panel1.Invalidate();
		}

		void panel1_Paint(object sender, PaintEventArgs e) {
			// the one animation parameter here is "step"
			int wOrig=image.Width;
			int hOrig=image.Height;
			int wFinal=panel1.Width;
			int hFinal=panel1.Height;
			// interpolate between initial and final image
			int w=(wOrig*(steps-step)+wFinal*step)/steps;
			int h=(hOrig*(steps-step)+hFinal*step)/steps;
			int x=(wFinal-w)/2;
			int y=(hFinal-h)/2;
			// now paint image
			e.Graphics.DrawImage(image, x, y, w, h);
		}

		private void btnAnimate_Click(object sender, EventArgs e) {
			if (step!=0) {
				step=steps;	// cancel the animation
			} else {
				// get parameters and validate them
				if (!int.TryParse(tbSteps.Text, out steps) || steps<1 || steps>1000) steps=50;
				tbSteps.Text=steps.ToString();
				int delay;
				if (!int.TryParse(tbDelay.Text, out delay) || delay<10 || delay>1000) delay=17;
				tbDelay.Text=delay.ToString();
				// paint the image on the Panel, and start timer for animation
				panel1.Invalidate();
				timer=new Timer();
				timer.Interval=delay;
				timer.Tick+=new EventHandler(timer_Tick);
				timer.Start();
				btnAnimate.Text="Cancel";
			}
		}

		void timer_Tick(object sender, EventArgs e) {
			step++;
			if (step>steps) {
				// terminate the animation
				step=0;
				timer.Stop();
				btnAnimate.Text="Animate";
			}
			panel1.Invalidate();
		}
	}
}
